ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.6 by root, Tue Dec 7 10:40:39 2010 UTC vs.
Revision 1.36 by root, Sun Mar 13 23:20:21 2011 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
42 42
43# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
44# required by mkbundle 44# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 46
47# which extra modules you might want to install 47# which extra modules you might want to install
48EXTRA_MODULES="" 48EXTRA_MODULES=""
49 49
50# overridable functions 50# overridable functions
51preconfigure() { : ; }
51postconfigure() { : ; } 52postconfigure() { : ; }
52postbuild() { : ; } 53postbuild() { : ; }
53postinstall() { : ; } 54postinstall() { : ; }
54 55
55# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
59 64
60############################################################################# 65#############################################################################
61# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
62 73
63# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
65$VERSION=0.1 76$VERSION="1.2"
66 77
67BZ2=bz2 78BZ2=bz2
68BZIP2=bzip2 79BZIP2=bzip2
69 80
70fatal() { 81fatal() {
103############################################################################# 114#############################################################################
104# clean 115# clean
105 116
106distclean() { 117distclean() {
107 verblock <<EOF 118 verblock <<EOF
108deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 120EOF
110 121
111 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
112} 123}
113 124
114############################################################################# 125#############################################################################
115# download/configure/compile/install perl 126# download/configure/compile/install perl
116 127
117clean() { 128clean() {
118 cd "$STATICPERL/src/perl-$PERL_VERSION" 2>/dev/null || return 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
119 131
120 rm -f staticstamp.configure 132realclean() {
121 make distclean >/dev/null 2>&1 133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
122} 136}
123 137
124fetch() { 138fetch() {
125 rcd "$STATICPERL" 139 rcd "$STATICPERL"
126 140
138perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
139trying $URL 153trying $URL
140EOF 154EOF
141 155
142 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
145 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
146 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
147 fi 162 fi
148 163
149 verblock <<EOF 164 verblock <<EOF
150unpacking perl 165unpacking perl
151EOF 166EOF
152 167
153 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
154 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xpC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar x ) \
155 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION
156 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
157 rmdir -p unpack 174 rmdir -p unpack
158 fi 175 fi
159} 176}
160 177
161# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
162sedreplace() { 179sedreplace() {
163 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
164 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
165} 209}
166 210
167configure() { 211configure() {
168 fetch 212 fetch
169 213
173 217
174 verblock <<EOF 218 verblock <<EOF
175configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
176EOF 220EOF
177 221
178 clean
179
180 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
181 223
224 "$MAKE" distclean >/dev/null 2>&1
225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
182 # I hate them 228 # I hate them for this
183 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
184 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231
232 preconfigure
185 233
186# trace configure \ 234# trace configure \
187 sh Configure -Duselargefiles \ 235 sh Configure -Duselargefiles \
188 -Uuse64bitint \ 236 -Uuse64bitint \
189 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
190 -Uusedl \ 238 -Uusedl \
191 -Uusethreads \ 239 -Uusethreads \
192 -Uuseithreads \ 240 -Uuseithreads \
193 -Uusemultiplicity \ 241 -Uusemultiplicity \
194 -Duseperlio \
195 -Uusesfio \ 242 -Uusesfio \
196 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
197 -Dcppflags="$PERL_CPPFLAGS" \ 245 -A ccflags=" $PERL_CCFLAGS" \
198 -Dccflags="-g2 -fno-strict-aliasing" \ 246 -Dcc="$PERL_CC" \
199 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
200 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
201 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
202 -Dprefix="$PERL_PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
203 -Dbin="$PERL_PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
204 -Dprivlib="$PERL_PREFIX/lib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
205 -Darchlib="$PERL_PREFIX/lib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
206 -Uusevendorprefix \ 254 -Uusevendorprefix \
207 -Dsitelib="$PERL_PREFIX/lib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
208 -Dsitearch="$PERL_PREFIX/lib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
209 -Usitelibexp \
210 -Uman1dir \ 257 -Uman1dir \
211 -Uman3dir \ 258 -Uman3dir \
212 -Usiteman1dir \ 259 -Usiteman1dir \
213 -Usiteman3dir \ 260 -Usiteman3dir \
214 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
215 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
216 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
217 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
218 $PERL_CONFIGURE \ 265 $PERL_CONFIGURE \
266 -Duseperlio \
219 -dE || fatal "Configure failed" 267 -dE || configure_failure
220 268
221 sedreplace ' 269 sedreplace '
222 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
223 s/ *-fno-stack-protector */ /g 271 s/ *-fno-stack-protector */ /g
224 ' config.sh 272 ' config.sh
239building $STATICPERL/src/perl-$PERL_VERSION 287building $STATICPERL/src/perl-$PERL_VERSION
240EOF 288EOF
241 289
242 rm -f "$PERL_PREFIX/staticstamp.install" 290 rm -f "$PERL_PREFIX/staticstamp.install"
243 291
244 make || fatal "make: error while building perl" 292 "$MAKE" || fatal "make: error while building perl"
245 293
246 postbuild || fatal "postbuild hook failed" 294 postbuild || fatal "postbuild hook failed"
247} 295}
248 296
249install() { 297install() {
250 [ -e "$PERL_PREFIX/staticstamp.install" ] && return 298 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
251
252 build 299 build
253 300
254 verblock <<EOF 301 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 302installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 303to $PERL_PREFIX
257EOF 304EOF
258 305
259 rm -rf "$PERL_PREFIX" 306 ln -sf "perl/bin/" "$STATICPERL/bin"
260 307 ln -sf "perl/lib/" "$STATICPERL/lib"
308
309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
310 rm -rf "$PERL_PREFIX" # by this rm -rf
311
261 make install || fatal "make install: error while installing" 312 "$MAKE" install || fatal "make install: error while installing"
262 313
263 rcd "$PERL_PREFIX" 314 rcd "$PERL_PREFIX"
264 315
265 # create a "make install" replacement for CPAN 316 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 318"$MAKE" || exit
319
320# patch CPAN::HandleConfig.pm
321HCPM="$PERL_PREFIX"/lib/CPAN/HandleConfig.pm
322case "\$(head -n1 "\$HCPM")" in
323 *CPAN::MyConfig* )
324 ;;
325 * )
326 echo "patching \$HCPM for a safer tomorrow"
327 {
328 echo "use CPAN::MyConfig;"
329 cat "\$HCPM"
330 } >"\$HCPM~"
331 rm -f "\$HCPM"
332 mv "\$HCPM~" "\$HCPM"
333 ;;
334esac
335
268if find blib/arch/auto -type f | grep -q -v .exists; then 336if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 337 echo Probably an XS module, rebuilding perl
270 make perl 338 if "$MAKE" perl; then
339 mv perl "$PERL_PREFIX"/bin/perl~ \
271 rm -f "$PERL_PREFIX"/bin/perl 340 && rm -f "$PERL_PREFIX"/bin/perl \
272 make -f Makefile.aperl inst_perl 341 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
273 make -f Makefile.aperl map_clean 342 "$MAKE" -f Makefile.aperl map_clean
343 else
344 "$MAKE" -f Makefile.aperl map_clean
345 exit 1
346 fi
274fi 347fi
348
349"$MAKE" install UNINST=1
275EOF 350EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 351 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 352
278 # trick CPAN into avoiding ~/.cpan completely 353 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 354 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
280 355
356 # we call cpan with -MCPAN::MyConfig in this script, but
357 # every make install will patch CPAN::HandleConfig.pm to
358 # protect the user.
359
281 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
282 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
283 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
284 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
285 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
286 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
287 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
288 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
289 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
290 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
291 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
292 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
293 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
294 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
295 375
376 touch "$PERL_PREFIX/staticstamp.install"
377 fi
378
379 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
296 NOCHECK_INSTALL=+ 380 NOCHECK_INSTALL=+
297 instcpan $STATICPERL_MODULES 381 instcpan $STATICPERL_MODULES
298 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 382 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
299 383
300 postinstall || fatal "postinstall hook failed" 384 postinstall || fatal "postinstall hook failed"
301 385
302 touch "$PERL_PREFIX/staticstamp.install" 386 touch "$PERL_PREFIX/staticstamp.postinstall"
387 fi
303} 388}
304 389
305############################################################################# 390#############################################################################
306# install a module from CPAN 391# install a module from CPAN
307 392
312installing modules from CPAN 397installing modules from CPAN
313$@ 398$@
314EOF 399EOF
315 400
316 for mod in "$@"; do 401 for mod in "$@"; do
317 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
318 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
319 done 404 done
320 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
321} 406}
322 407
334 for mod in "$@"; do 419 for mod in "$@"; do
335 echo 420 echo
336 echo $mod 421 echo $mod
337 ( 422 (
338 rcd $mod 423 rcd $mod
339 make -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
340 make distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
341 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
342 make || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
343 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
344 make distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
345 exit 0 430 exit 0
346 ) || exit $? 431 ) || exit $?
347 done 432 done
348} 433}
349 434
350############################################################################# 435#############################################################################
351# main 436# main
352 437
353podusage() { 438podusage() {
354 echo 439 echo
440
355 if [ -e "$PERL_PREFIX/bin/perl" ]; then 441 if [ -e "$PERL_PREFIX/bin/perl" ]; then
356 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 442 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
357 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 443 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
358 2>/dev/null && exit 444 2>/dev/null && exit
359 fi 445 fi
446
360 # try whatever perl we can find 447 # try whatever perl we can find
361 perl -MPod::Usage -e \ 448 perl -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 449 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 450 2>/dev/null && exit
364 451
365 fatal "displaying documentation requires a working perl - try '$0 install' first" 452 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
366} 453}
367 454
368usage() { 455usage() {
369 podusage 0 456 podusage 0
370} 457}
380} 467}
381 468
382bundle() { 469bundle() {
383 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 470 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
384 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 471 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
472 CACHE="$STATICPERL/cache"
473 mkdir -p "$CACHE"
385 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 474 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
386} 475}
387 476
388if [ $# -gt 0 ]; then 477if [ $# -gt 0 ]; then
389 while [ $# -gt 0 ]; do 478 while [ $# -gt 0 ]; do
390 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 479 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
391 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 480 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
392 481
393 command="${1#--}"; shift 482 command="${1#--}"; shift
394 case "$command" in 483 case "$command" in
484 version )
485 echo "staticperl version $VERSION"
486 ;;
395 fetch | configure | build | install | clean | distclean) 487 fetch | configure | build | install | clean | realclean | distclean)
396 verblock <<EOF
397$command
398EOF
399 ( "$command" ) 488 ( "$command" ) || exit
400 ;; 489 ;;
401 instsrc ) 490 instsrc )
402 ( instsrc "$@" ) 491 ( instsrc "$@" ) || exit
403 exit 492 exit
404 ;; 493 ;;
405 instcpan ) 494 instcpan )
406 ( instcpan "$@" ) 495 ( instcpan "$@" ) || exit
407 exit 496 exit
408 ;; 497 ;;
409 cpan ) 498 cpan )
410 ( install ) 499 ( install ) || exit
411 "$PERL_PREFIX/bin/cpan" "$@" 500 "$PERL_PREFIX/bin/cpan" "$@"
412 exit 501 exit
413 ;; 502 ;;
414 mkbundle ) 503 mkbundle )
415 ( install ) 504 ( install ) || exit
416 bundle "$@" 505 bundle "$@"
417 exit 506 exit
418 ;; 507 ;;
419 mkperl ) 508 mkperl )
420 ( install ) 509 ( install ) || exit
421 bundle --perl "$@" 510 bundle --perl "$@"
511 exit
512 ;;
513 mkapp )
514 ( install ) || exit
515 bundle --app "$@"
422 exit 516 exit
423 ;; 517 ;;
424 help ) 518 help )
425 podusage 2 519 podusage 2
426 ;; 520 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines